.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc
include  \masm32\include\shell32.inc
include  \masm32\include\comdlg32.inc
include  \masm32\include\gdi32.inc
include  \masm32\include\advapi32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\shell32.lib
includelib  \masm32\lib\comdlg32.lib
includelib  \masm32\lib\gdi32.lib
includelib  \masm32\lib\advapi32.lib

include \masm32\macros\macros.asm
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc    PROTO : HWND, : UINT, : WPARAM, : LPARAM
; Macros
; ------------------------------------------------------------------------------
m2m MACRO M1, M2
	push M2
	pop  M1
ENDM


GETV MACRO dVar
	mov eax,dVar 
  EXITM <eax>
ENDM
; ------------------------------------------------------------------------------
.const
; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	  equ 101
IDI_ICON      equ 200
IDC_TIMER	= 10

; ################################# creats font size so letters are not to big	
TEXTFONT		equ "Acknowledge -BRK-" ; you could have whatever font here! For Example "Viner Hand ITC" any fonts that are avialable in Microsoft Office Word!!!
; ################################# creats font size so letters are not to big	
COLORDLG		equ 00C0C0C0h;Black ; Dialog colour (Natural window coour is 00D8E9ECh)
COLORTEXT		equ 00FFFFFFh ; Text coulor
SCROLLSPEED		equ 35 ; Scroll Speed -> a lesser Number = Faster!
FONTZ			equ 400

; Required data

.data
szTitle    db "Scroll Text Up Example ", 0

;----------------------------------------------------------------------------
szWindowMsg  db 'Welcome to MASM32, state of the art Windows assembler programming.',0Dh,0Ah
            db 0Dh,0Ah ; puts a space ! 
            db 0Dh,0Ah 
            db 'Many remember assembler as a complex and tedious necessity when a high level',0Dh,0Ah
            db 'language failed to deliver in terms of capacity or performance yet it has always ',0Dh,0Ah
            db 'been capable of writing full size applications in elegant and efficient ways.',0Dh,0Ah 
            db 'MASM has the capacity to write proper modular code which becomes a necessity as',0Dh,0Ah 
            db 'a project becomes larger.',0Dh,0Ah
            db 0Dh,0Ah 
            db 'Assembler has the freedom to write code ranging from the self imposed structural ',0Dh,0Ah
            db 'approach to unrestrained freestyle code, each having their respective',0Dh,0Ah 
            db 'advantages. Self imposed modular coding has the advantage of organisation,',0Dh,0Ah 
            db 'particularly with larger projects where freestyle has its advantages in close',0Dh,0Ah 
            db 'range loop optimisation code.',0Dh,0Ah
            db 0Dh,0Ah 
            db 'Performance to size ratio assembler code uses both approaches which takes',0Dh,0Ah 
            db 'advantage of many of the higher level language',27h,'s efficiency techniques such as',0Dh,0Ah 
            db 'code reuse while being able to specifically target speed critical code where itis necessary.',0Dh,0Ah 
            db 0Dh,0Ah 
            db '32 bit assembler is both clearer and simpler than the DOS and 16 bit Windows',0Dh,0Ah 
            db 'code and is not cursed with the complexity of segment arithmetic. You no longer',0Dh,0Ah 
            db 'have to deal with AX:DX pairs for long integers and there is no 64k boundary',0Dh,0Ah 
            db 'imposed by the segmented structure of 16 bit software.',0Dh,0Ah
            db 0Dh,0Ah 
            db 'The complexity of writing 32 bit Windows software is related to the structure of',0Dh,0Ah 
            db 'Windows and the sheer range of functions in the API set. It differs from DOS',0Dh,0Ah
            db 'code only in so far as the parameters are passed on the stack rather than in',0Dh,0Ah 
            db 'registers as in the DOS interrupts.',0Dh,0Ah
            db 0Dh,0Ah 
            db 'While the sheer range of functions in Window can be a bit intimidating, it also',0Dh,0Ah 
            db 'puts in the hands of the assembler language programmer, a massive set of',0Dh,0Ah 
            db 'capacities that were never available in DOS.',0Dh,0Ah
            db 0Dh,0Ah 
            db 'One of the advantages of writing in assembler is that it comfortably handles the',0Dh,0Ah 
            db '"C" format of the Windows APIs with no difficulty. Zero terminated strings,',0Dh,0Ah 
            db 'structures, pointers, data sizes etc... are all part of writing assembler.',0Dh,0Ah,0  
    
;----------------------------------------------------------------------------

DELAY_VALUE	equ	10
ScrollOffset		DWORD	1

.data?
hInstance	dd	?
hIcon     HICON ?
brush		dd	?
hBgColor     	HBRUSH	?
hFontWindow	HFONT		?
WindowRect    	RECT   <?>
rScroll		    RECT   <?>
rClientWindow	RECT   <?>
PosRct		RECT	   <?>
hbmp		HANDLE		?
hmainDC       HDC       ?
;hmainDC		HDC		    ?
TimerID		DWORD		?


.code

start:
INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
INVOKE InitCommonControls
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0

; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

LOCAL	ps:PAINTSTRUCT
LOCAL	hdc:HDC
 .IF uMsg == WM_INITDIALOG

  INVOKE SetWindowText, hWnd, addr szTitle 
  INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon  
; ################################# creats colour window		
    ;invoke CreateSolidBrush,COLORDLG
    invoke CreateSolidBrush,NULL_BRUSH
	mov hBgColor,eax
; ################################# creats colour window	

; ################################# creats font size so letters are not to big	
;NOTE: you could chance "FW_NORMAL" with "FW_BOLD" ...See CreateFont API for more options!
	mov hFontWindow,FUNC(CreateFont,15, 0, 0, 0, FW_NORMAL, 0, 0, 0, 0, 0, 0, 0, 0, SADD(TEXTFONT)) ; first number is the font size!!
	mov eax,PosRct.left
	add eax, 130
	mov ebx,PosRct.top
	add ebx, 100
; ################################# creats font size so letters are not to big	

		invoke GetClientRect,hWnd,ADDR WindowRect
	mov hdc,FUNC(GetDC,hWnd)
	mov hmainDC,FUNC(CreateCompatibleDC,hdc); creats window
	mov hbmp,FUNC(CreateCompatibleBitmap,hdc,WindowRect.right,WindowRect.bottom); creats window
		invoke SelectObject,hmainDC,hbmp
	mov rClientWindow.top,1
	mov rClientWindow.left,1
	m2m rClientWindow.right,WindowRect.right
	m2m rClientWindow.bottom,WindowRect.bottom    
	dec rClientWindow.bottom
	dec rClientWindow.right
	invoke FillRect,hmainDC,ADDR WindowRect,hBgColor ; color for window

; ################################# highlights the text (creats colour to match background colour)		
invoke SetTextColor,hmainDC,COLORTEXT ;colour the text

invoke SetBkMode,hmainDC,NULL_BRUSH ;make text background transparent

; ################################# highlights the text (creats colour to match background colour)

		invoke IntersectClipRect,hmainDC,rClientWindow.left,rClientWindow.top,rClientWindow.right,rClientWindow.bottom
	
		invoke SelectObject,hdc,hFontWindow	  		
		invoke DrawText,hdc,ADDR szWindowMsg,-1,ADDR rScroll,DT_CALCRECT + DT_NOPREFIX + DT_LEFT + DT_TOP + DT_NOCLIP
	
	m2m rScroll.right,rClientWindow.right
	sub rScroll.right,5
	add rScroll.top,GETV(rClientWindow.bottom)
	add rScroll.bottom,eax	
			
		invoke ReleaseDC,hWnd,hdc	
			
	mov TimerID,FUNC(SetTimer,hWnd,IDC_TIMER,SCROLLSPEED,NULL)
	
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,addr ps
	mov hdc,eax
		invoke FillRect,hmainDC,ADDR rScroll,rv(GetStockObject,TRANSPARENT) ; OPAQUE VS BLACK_BRUSH VS TRANSPARENT
		invoke SelectObject,hmainDC,hFontWindow	
		invoke DrawText,hmainDC,ADDR szWindowMsg,-1,ADDR rScroll,DT_CENTER + DT_TOP + DT_NOPREFIX + DT_NOCLIP  
;NOTE: DT_CENTER Centers the Teext...DT_LEFT or DT_RIGHT could be used insted!!!		
		invoke BitBlt,hdc,0,0,WindowRect.right,WindowRect.bottom,hmainDC,0,0,SRCCOPY
		invoke EndPaint,hWnd,addr ps
	
	.elseif uMsg == WM_TIMER
	add rScroll.top,GETV(ScrollOffset)
	add rScroll.bottom,eax			
	.if SDWORD PTR rScroll.top >= GETV(rClientWindow.bottom)
	mov ScrollOffset,-1	
; Scroll Text back down	
	.ELSE
	.if SDWORD PTR rScroll.bottom <= GETV(rClientWindow.top)
	mov ScrollOffset,1		
	.endif	
; Scroll Text back down		
	.endif			
		invoke InvalidateRect,hWnd,NULL,FALSE

	.elseif uMsg == WM_CLOSE 
	mov rScroll.top,0
	mov rScroll.bottom,0
	mov rScroll.left,0
	mov rScroll.right,0
		invoke DeleteDC,hmainDC 
		invoke DeleteObject,hbmp
		invoke KillTimer,hWnd,TimerID
		invoke EndDialog,hWnd,NULL
	
	.else
		return FALSE    
	.endif
		return TRUE

xor eax,eax 
	Ret
DialogProc endp

end start